
defmodule PPong do

  def go() do go(10) end
  def go(n) do
     pid1 = spawn_link(__MODULE__ , :ping , [])
     pid2 = spawn_link(__MODULE__ , :pong , [])
     IO.puts("Ping PID is #{inspect(pid1)}")
     IO.puts("Pong PID is #{inspect(pid2)}")
     Process.register(pid1, :pingID)
     Process.register(pid2, :pongID)
     send(:pongID, :ping) # get the ball rolling 
     :timer.sleep(:timer.seconds(n))
     send(:pingID, :halt) # get the ball rolling 
     
  end

  def ping() do
     receive do
       :pong -> 
          IO.puts("#{inspect(self())} got pong...")
          :timer.sleep(1000)
          send(:pongID, :ping)
          ping()
       :halt -> exit(:kill)
     end
  end

  def pong() do
     receive do
       :ping -> 
          IO.puts("#{inspect(self())} got ping...")
          :timer.sleep(1000)
          send(:pingID, :pong)
          pong()
     end
  end

end

