
defmodule Stack do

  def new() do [] end

  def pop([]) do {nil, []} end
  def pop(stack) when stack != [] do
    [last_in | rest] = stack
    {last_in, rest}
  end

  def push(stack, item) do [item | stack] end

  def size(stack) do Enum.count(stack) end

  def top([]) do nil end 
  def top([item|_]) do item end 

end
