
defmodule PascalTriangle do

  defp next_row(m), do: 
     for(x <- (-1..Map.size(m)-1), do: 
        { (x+1), Map.get(m, x, 0) + Map.get(m, x+1, 0) } ) 
        |> Map.new

  def draw(1), do: (IO.puts(1); %{ 0 => 1})
  def draw(n) do
    (new_map = draw(n - 1) |> next_row ) 
       |> Map.values 
       |> Enum.join(" ") 
       |> IO.puts
    new_map
  end

end
