
defmodule PPong2 do

  def go() do go(10) end
  def go(n) do
     pid1 = spawn_link(__MODULE__ , :ping , [])
     pid2 = spawn_link(__MODULE__ , :pong , [])
     IO.puts("Ping PID is #{inspect(pid1)}")
     IO.puts("Pong PID is #{inspect(pid2)}")
     #Process.register(pid1, :pingID)
     #Process.register(pid2, :pongID)
     send(pid2, :ping) # get the ball rolling 
     :timer.sleep(:timer.seconds(n))
     send(pid1, :halt) # get the ball rolling 
     
  end

  def ping() do
     receive do
       {:ping, PID} -> 
          IO.puts("#{inspect(self())} got pong from #{inspect(PID)}")
          :timer.sleep(1000)
          send(PID, {:ping,self()})
          ping()
       :halt -> exit(:kill)
     end
  end

  def pong() do
     receive do
       {:ping, PID} -> 
          IO.puts("#{inspect(self())} got ping #{inspect(PID)}")
          :timer.sleep(1000)
          send(PID, {:pong,self()})
          pong()
     end
  end

end

